#include "inputdev.hh"
#include "config.h"

#ifdef HAVE_SYS_IOCTL_H
#include <sys/ioctl.h>
#endif

#ifdef DJGPP
#include <conio.h>
#else
#ifdef HAVE_TERMIO_H
#include <termio.h>
#endif
#ifdef HAVE_TERMIOS_H
#include <termios.h>
#endif
#endif

#include <unistd.h>
#include <sys/time.h>
#include <sys/types.h>
#include <fcntl.h>
#include <cerrno>

Input::Input()
{
    back = new termio;
    ioctl(0, TCGETA, back);
    
    SetBlocking(true);
}
Input::~Input()
{
    ioctl(0, TCSETA, back);
    delete back;
}
void Input::SetBlocking(bool block)
{
    struct termio term = *back;
    
    // Disable linebuffer and echoing
    // Disable signals generated by ^C, ^Z and ^] (int,stop,quit)
    term.c_lflag &= ~(ICANON|ECHO|ISIG);
    
    // Disable special handling of ^S and ^Q
    term.c_iflag &= ~(IXON);
    
    term.c_cc[VMIN] = block ? 1 : 0;
    ioctl(0, TCSETA, &term);
}
int Input::Read()
{
    unsigned char c;
    if(read(0, &c, 1) <= 0)return -1;
    return c;
}
int Input::Kbhit(unsigned micros)
{
    fd_set fds;
    FD_ZERO(&fds);
    FD_SET(0, &fds);
    struct timeval t = {0,micros};
    return select(1, &fds, NULL, NULL, &t);
}

Input InputDev;
