#ifndef bsq_inputfield_hh
#define bsq_inputfield_hh

#include "autoptr.hh"
#include "inputevent.hh"

class InputField : public ptrable
{
protected:
    bool focused;
    
    class InputGroup *owner;
    friend class InputGroup;
    inline void SetOwner(class InputGroup *o) { owner = o; }
public:
    InputField()
    {
        focused = false;
    }
    virtual ~InputField()
    {
    }

    // Returns true if the event was handled (ate).
    virtual bool Handle(const InputEvent &ev) = 0;
    
    virtual void LostFocus() { focused = false; redraw(); }
    virtual void GotFocus()  { focused = true; redraw(); }
    
    virtual void redraw() = 0;
};

#endif
