#include "loadmeter.hh"

LoadMeter::LoadMeter(const char *fmt...) : region(Display.AllocateLine())
{
    va_list ap;
    va_start(ap, fmt);
    unsigned len = region.printf(fmt, ap);
    va_end(ap);
    
    max = region.xsize() - 9 - len;
    
    region.printf(" [");
    region.putchar('.', max);
    region.printf("]");
    region.putchar('\b', max+1);
    region.flush();
    
    pos = 0;
    lastp = 101;
}

void LoadMeter::tick(long n, long whole)
{
    unsigned newpos = n * (max+1) / (whole+1);
    
    if(pos < newpos)
        region.putchar(':',  newpos-pos);
    else
        region.puts("\b.\b", pos-newpos);
        
    unsigned p = n * 101 / (whole+1);
    if(p != lastp)
    {
        lastp = p;
        unsigned x = region.wherex();
        region.gotox(region.xsize() - 6);
        region.printf(" %3u%%", p);
        region.gotox(x);
    }
    region.flush();
    
    pos = newpos;
}
